

function love.load()

  love.graphics.setDefaultFilter('nearest', 'nearest')
  Object = require 'libraries/classic'
  anim8 = require 'libraries/anim8'
  sti = require 'libraries/sti'   
  gameMap = sti('maps/monMap.lua') 
  tick = require 'libraries/tick'
  require 'Player'
  require 'Coin'
  
  isGameOver = false
  gameFont = love.graphics.newFont(25)
  
  Coin = Coin()
  Player = Player()

  sound = {
    music = love.audio.newSource('sounds/game-music.mp3' , 'stream'),
    point = love.audio.newSource('sounds/Coin- pickup.wav' , 'static')
  }
  
  fonts = {
        primary = love.graphics.newFont("fonts/Alatsi-Regular.ttf", 48),
        colorPrimary = {1, 2, 1},
        secondary = love.graphics.newFont("fonts/troika.otf", 20),
        colorSecondary = {1, 1, 0}
    }
    
  sound.music:setLooping(true)
  sound.music:play()
  
  score = 0
  time = 10
  
end


function love.update(dt)
  if isGameOver then
    return 
  end
  
  if Player.x + Player.w > Coin.x
  and Player.x < Coin.w + Coin.x 
  and Player.y + Player.h > Coin.y
  and Player.y < Coin.h + Coin.y then
    score = score + 1
    Coin.x = math.random(800 - Coin.image:getWidth())
    Coin.y = math.random(600 - Coin.image:getHeight())
  end 
  
  Player:update(dt)
  Coin:update(dt)
  tick.update(dt)

  time = time - dt
  if time <= 0 then
    isGameOver = true
  end 
  
end

function love.draw()
  if isGameOver then
    GameOverInfo()
    return
  end 
  
  gameMap:draw()
  Player:draw()
  Coin:draw()
  love.graphics.print('Score:' .. math.floor(score), fonts.secondary, 20, 10)
  love.graphics.print('time:' .. math.floor(time), fonts.secondary, 20, 30)
end 

function gameover()
  isGameOver = true
  sound.music:stop()
  sound.music:setLooping(false)
end 

function GameOverInfo()     

  gameMap:draw()  
  
  love.graphics.setColor(fonts.colorPrimary)
  love.graphics.print('Game Over', fonts.primary, 200, love.graphics.getHeight()/2 - (48 + 20))
    
  love.graphics.setColor(fonts.colorSecondary)
  love.graphics.print('You Collected ' .. score .. ' coins.', fonts.secondary, 200, love.graphics.getHeight()/2 )
    
end